package cn.iocoder.yudao.module.member.service.storegoodstype;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.member.controller.admin.storegoodstype.vo.*;
import cn.iocoder.yudao.module.member.dal.dataobject.storegoodstype.StoreGoodsTypeDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.member.dal.mysql.storegoodstype.StoreGoodsTypeMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.member.enums.ErrorCodeConstants.*;

/**
 * 商品类别 Service 实现类
 *
 * @author 管理员
 */
@Service
@Validated
public class StoreGoodsTypeServiceImpl implements StoreGoodsTypeService {

    @Resource
    private StoreGoodsTypeMapper storeGoodsTypeMapper;

    @Override
    public Integer createStoreGoodsType(StoreGoodsTypeSaveReqVO createReqVO) {
        // 插入
        StoreGoodsTypeDO storeGoodsType = BeanUtils.toBean(createReqVO, StoreGoodsTypeDO.class);
        storeGoodsTypeMapper.insert(storeGoodsType);
        // 返回
        return storeGoodsType.getId();
    }

    @Override
    public void updateStoreGoodsType(StoreGoodsTypeSaveReqVO updateReqVO) {
        // 校验存在
        validateStoreGoodsTypeExists(updateReqVO.getId());
        // 更新
        StoreGoodsTypeDO updateObj = BeanUtils.toBean(updateReqVO, StoreGoodsTypeDO.class);
        storeGoodsTypeMapper.updateById(updateObj);
    }

    @Override
    public void deleteStoreGoodsType(Integer id) {
        // 校验存在
        validateStoreGoodsTypeExists(id);
        // 删除
        storeGoodsTypeMapper.deleteById(id);
    }

    private void validateStoreGoodsTypeExists(Integer id) {
        if (storeGoodsTypeMapper.selectById(id) == null) {
            throw exception(STORE_GOODS_TYPE_NOT_EXISTS);
        }
    }

    @Override
    public StoreGoodsTypeDO getStoreGoodsType(Integer id) {
        return storeGoodsTypeMapper.selectById(id);
    }

    @Override
    public PageResult<StoreGoodsTypeDO> getStoreGoodsTypePage(StoreGoodsTypePageReqVO pageReqVO) {
        return storeGoodsTypeMapper.selectPage(pageReqVO);
    }

    @Override
    public List<StoreGoodsTypeDO> getAll() {
        return storeGoodsTypeMapper.selectList();
    }
}